


//------------------------------------------------------------------------------
// Programmed by Christof Ermer
// Regensburg JANUAR  2006 und ab 27.09.2024 
//------------------------------------------------------------------------------

///SYSINFO
#define VERSION		"Drehfilter mit SonderKeyfunktion ( Not STANDARD)" 
#define DATUM		"08.10.2024"	 //"15.3.2007"
#define	INSTITUT	"UNI-Regensburg"
#define AUTOR		"Christof Ermer"

// TEST DEVCPP
//B:\Drive\NASDrive\DEV_Cpp_NAS\DrehfilterTest_DEVCPP__LWC_07.10.24_1


// SCHALTER 
//IN MAIN.H

/*HiSTORY
Rckbau der LED INdexxer, 
'Einbau eines Gabelkopplers am PC0, HIGH = Gesachlossen

#define AVR_ATmega16
FUSE  H=xBF L=x89   09.24
SET COPT IN  FUSE BITS TO ENABLE XTAL

BAUDRATE = 9600,8,N,1
ICTRL = PD6
Neuer Indexer, Gabelkkoppler Wird high an PINC.0  09.24

NEUE AVRDUDE Version in make
# Program the device.  
program: $(TARGET).hex $(TARGET).eep
#	$(AVRDUDE) $(AVRDUDE_FLAGS) $(AVRDUDE_WRITE_FLASH) $(AVRDUDE_WRITE_EEPROM)
	"C:\AVRDUDE\avrdude.exe" $(AVRDUDE_FLAGS) $(AVRDUDE_WRITE_FLASH) $(AVRDUDE_WRITE_EEPROM)


Strom nicht sofort auf Low geschaltet, sondern nach DelayTime
The maximal possible delay is 262.14 ms / F_CPU in MHz. = 16,39625

NDERUNG ENABLE IMMER AN !!!

PIN 33 PA7=ADC7 wird Enable ICtrl ber BUZ 11 wird ein Widerstand 2*4R7 5W auf GND Kurzgesloosen
% Modulo geht nur mit 2 Hoch N Reihen als Modulo..

// **** Hystorie Hystorie Hystorie Hystorie Hystorie Hystorie ****************
 commado MCA_CMD zugefgt

FLOAT TIMER UMGESTELLT
nderung der Bezge durch float Grad in Steps, Bezogen auf Motor mode und Steps/Rotation
STEPMotor ist an PORT A vorgesehen..

// IF ( ? : );
*/

#include <ctype.h>
#include <inttypes.h>
#include <avr\io.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>
#include <avr\pgmspace.h>
#include <avr\eeprom.h>	
#include <util\delay.h>
#include <avr\wdt.h>

#include "main.h"		//with Hardware assigns
#include "uart.h"
#include "lcd.h"


// GLOBALE VARIABLEN 
volatile STATUS_TYPE gsStatus; //gsStatus.TickEvent
volatile uint32_t gulT2_Ticks; //  T2 timeCounter, only NN_Counter for Keypressingsuint32_t gu32TimeLatch; //Speed watch 
volatile uint32_t gu32TimeLatch; //Speed watch 

char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
char gcaNumStr[NUMMAX + 1]; //+1 for the 0
char gcaStr[STRMAX + 1]; //+1 for the 0

COMMAND_TYPE gsCmd;
char* gpcRxPars;

//STEP MOTOR RELATED
volatile STEPMPARTYPE gsStMPar;		//SPEICHERT DIE PARAMETER //deklarion in Main.H
volatile uint8_t gu8StepBitMusterPars; //+1 or -1 for the Bitpatternselect
volatile uint8_t gu8ModePatternModulo; // Modulo selector (HALF/FULLSTEP..)
PGM_P gpmpaStepPattern;  // PGM_P PGM_VOID_P 
volatile uint32_t gulMovedSteps;	//compare with MovedSteps //Wieviel hat sich der Motor gedreht..	
uint32_t gulSM_ToRunCnt;	//PULSE die der Motor laufen soll	

// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
long glSM_RotPosition;	//Single_Rotation-Haupzthler der Position! MUSS NEGATIV WERDEN KNNEN
volatile float gfBigWeel_FullRotCnt;	//200*2* (40/12) = 666.66666
volatile float gfStepsPerDegree;// WeelFullRotationsteps= 666.666/360 = 1,851851667.............
volatile float gfDegreePerStep;// 360/666.666 WeelFullRotationsteps / = 0.54000054
volatile float gfBigWeel_GradPos;	
volatile float gfBigWeel_Target_GradPos ;	
// !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


const char MCA_CRSTR[] PROGMEM = {13,0};
const char MCA_CRLFSTR[] PROGMEM = {13,10,0};
const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };

//MESSAGES 
const char MCA_DELIMITER_MSG[] PROGMEM	= ",";
const char MCA_DPOINT_MSG[] PROGMEM = ":";
const char MCA_SPACE_MSG[] PROGMEM	= " ";
const char MCA_ISTGLEICH_MSG[] PROGMEM	= "=";

//const char MCA_EVENT_MSG[] PROGMEM	= "Event";
const char MCA_OK_MSG[] PROGMEM		= "OK";	
const char MCA_MOTOR_MSG[] PROGMEM	= "Motor";	
const char MCA_POS_MSG[] PROGMEM	= "Pos";


//FULLSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0011 1001 = 0x39
//0011 0101 = 0x35
//0011 0110 = 0x36
//const MCA_FULLSTEPS[] PROGMEM = {0xBA,0xB9,0xB5,0xB6};	//CONST ARRAY
const char MCA_FULLSTEPS[] PROGMEM = {0x3A,0x39,0x35,0x36};	//CONST ARRAY
//HALFSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0010 1000 = 0x28
//0011 1001 = 0x39
//0001 0001 = 0x11
//0011 0101 = 0x35
//0010 0100 = 0x24
//0011 0110 = 0x36
//0001 0010 = 0x12
const char MCA_HALFSTEPS[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12};	//CONST ARRAY


// ******************
ISR(TIMER2_COMP_vect)
// ******************
{
if( !( (++gulT2_Ticks) % ONE_SECOND_TICKS) )
	{
	gsStatus.TickEvent_F = 1; // Sec Event
	}
//( READ_SENS_INDEX_ACTIVE_ISHIGH() ? (gsStatus.OptoKopplerActive_F = 1) : (gsStatus.OptoKopplerActive_F = 0) ); 
};

// ****************************************************************
ISR(TIMER1_COMPA_vect)// signal handler
//#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// ******************
{
//static uint8_t ucBitpattern;
//I_SREG automtaic clear by Interrupt and Enabled by RETI	
//cli();f
if( gsStMPar.u8StepMConditionFlag & STEPM_RUN_FLAG )
	{
	//Target ->meint Target in einer Rotation
	if( (gsStMPar.u8SM_PostionFlag & POSITION_STOP_ON_TARGET_MODE_FLAG)// &&
	//Ziel so nahe wie mglich erreicht ? Also kleiner 1 Step...==40/12=3.3333
	)
		{
		gsStMPar.u8SM_PostionFlag &= ~POSITION_STOP_ON_TARGET_MODE_FLAG; //SCHON In  StepMotorStop();
		StepMotorStop();		
		gsStMPar.u8SM_PostionFlag |= POSITION_STOP_ON_TARGET_OK; //Meldung fr main schon in motorstop
		return;		
		};

	if( gsStMPar.u8StepMConditionFlag & STEPM_DIRECTION_FLAG )		
		{//Linksrum Relativ zu Markerpfeil am Rand....
		gu8StepBitMusterPars--;
		glSM_RotPosition--;		
		gfBigWeel_GradPos -= gfDegreePerStep; 
		}
	else
		{//Rechts
		gu8StepBitMusterPars++;
		glSM_RotPosition++;
		gfBigWeel_GradPos += gfDegreePerStep; 
		};	
	gu8StepBitMusterPars &= gu8ModePatternModulo;
	//glSM_RotPosition %= gsStMPar.uiStepsPerRotation;		
	gfBigWeel_GradPos = FloatZahlenRing( gfBigWeel_GradPos, 360.0);
	
	ICTRL_HIGHPWR()	;
	//Zuerst  Bitmuster whlen, damit Motor immer auf gu8StepBitMusterPars steht.
	STEPCTRL_PORTX =  //Aktueller Steppars..Enabeln
		((STEPCTRL_PORTX) & (~STEPAMP_ALLCTRL_MASK))	| //ODER . erhalte alle anderen Bits	
		(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + gu8StepBitMusterPars) ) ); 			 

	gulMovedSteps++; //Zhle die Pulse.. !!		
	wdt_reset();	//WATCHDOG 	

	//check MOP Count...
	if( gsStMPar.u8StepMConditionFlag & STEPM_PULSE_MODE_FLAG )
		{
		if( gulMovedSteps >= gulSM_ToRunCnt )
			{		
			StepMotorStop();	//EVTL. MIT AUTORELEASE_TIMEOUT
			//gsStMPar.u8StepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG;
			//gsStatus.TargetSMPOS_Erreicht_F = 1;
			};
		};		
		

	if( gsStatus.SMRUN_To_absoluteTarget_GradPOS_F )
		{
		if( round(gfBigWeel_GradPos)  == round(gfBigWeel_Target_GradPos) )
			{
			StepMotorStop();	//EVTL. MIT AUTORELEASE_TIMEOUT
			//gsStatus.TargetSMPOS_Erreicht_F = 1;
			//gsStatus.SMRUN_To_absoluteTarget_GradPOS_F = 0;
			};
/*
		else
			{
			//gsStatus.TargetSMPOS_Erreicht_F = 0;
			}
*/		};

// Check_Detectors
	if( gsStatus.ScanIndexRunning_F ) //IDX sci gefunden
		{
		wdt_reset();	//WATCHDOG
		if ( (gsStatus.OptoKoppler_OLD_VAL_F == 0) && READ_SENS_INDEX_ACTIVE_ISHIGH() ) // wechsel von 0 auf 1
			{		
			gsStatus.ScanIndexRunning_F = 0;
			StepMotorStop();
			Set_StepFRQ( gsStMPar.fStepMot_FRQ );
			gsStatus.IndexOK_F = 1;
			gsStatus.NewIndexFound_F = 1;
			glSM_RotPosition = 0;
			gfBigWeel_GradPos = 0; // 0..666.66
			}
		else  //0=Hier nicht gefunden
			{
			gsStatus.IndexOK_F = 0;
			gsStatus.OptoKoppler_OLD_VAL_F =  READ_SENS_INDEX_ACTIVE_ISHIGH();
			if( (gulT2_Ticks - gu32TimeLatch) > SM_IDX_SCAN_TIMEOUT ) // TimeOut
				{
				gsStatus.TimeOut_F = 1;
				gsStatus.ScanIndexRunning_F = 0;
				StepMotorStop();
				};				
			};
		}; //IDX Scan
		//---------------------
	}
else	//gsStMPar.u8StepMConditionFlag & STEPM_ENABLE_FLAG
	{
	StepMotorStop();
	};
};




// *************************************
void StartTimer2(void)	//0.1 Seconds  interrupt
// *************************************
{
TIMSK &= ~ _BV( OCIE2 );
gulT2_Ticks = 0;
OCR2 = 250;
TCNT2 = 0;	//Timer MAX = TOP Compare
TIMSK |= _BV( OCIE2 ); // BESSER
TCCR2 = _BV( WGM21) | TCCR2_CLK_256;	//CTC  ( _BV(CS22) | _BV(CS21) )
sei();
};


//****************************************************************
float FloatZahlenRing(float fZahl, float fLimit ) 
//****************************************************************
{
if( fZahl >= fLimit )
	{
	fZahl -= fLimit;
	};
if( fZahl < 0)
	{
	fZahl += fLimit;
	};
return fZahl;
};


// ******************
char* FloatToNumStr(double fVal)
// *************
{
return dtostrf(fVal, FLOAT_PRAEDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};

// **********************************************
char* LongToNumStr(int32_t lVal)
// **********************************************
{
return ltoa(lVal, gcaNumStr, 10 );
};

// **********************************************
char* ULongToNumStr(uint32_t ulVal)
// **********************************************
{
return ultoa(ulVal, gcaNumStr, 10 );
};

// *******************************************************************
char * ByteToBin(uint8_t u8Byte)
// *******************************************************************
{
static char caHex[9]; //groesse 8+1
char * pcParser = caHex;
int8_t i8NN=7;
do
	{
	if( u8Byte & (1 << i8NN) )
		{
		*pcParser = '1';
		}
	else
		{
		*pcParser = '0';
		};
	pcParser++;
	}while(i8NN--);
caHex[8]=0; //Terminierung
return caHex;
};

int32_t Round(double fIn)
// **********************************************
{
return (int32_t)floor(fIn + 0.5);
};


// ******************
void Print_CRLF_CR(void)  //1=CRLF,0=CR ->gsStatus.CRLF_CR_F
// ******************
{
( gsStatus.CRLF_CR_F ? uart_puts_p(MCA_CRLFSTR) : uart_puts_p(MCA_CRSTR) );
};

// ******************
void Print_Str(const char* pStr)
// ******************
{
uart_puts(pStr);
};

// ******************
void Print_PStr(PGM_P pmStr)
// ******************
{
uart_puts_p(pmStr);
};

// ******************
void PrintOK_CRLF(void)
// ******************
{
uart_puts_p( PSTR("OK") );
Print_CRLF_CR();
}; 

// ******************
void Print_StrCRLF(const char* pStr)
// ******************
{
uart_puts(pStr);
Print_CRLF_CR();
};

// ******************
void Print_PStrCRLF(PGM_P pmStr)
// ******************
{
uart_puts_p(pmStr); Print_CRLF_CR();
};


// ******************
void PrintFloatCRLF(double fVal)
// ******************
{
FloatToNumStr(fVal); Print_StrCRLF(gcaNumStr);
};

// ******************
void PrintLongCRLF(int32_t lVal)
// ******************
{
LongToNumStr(lVal); Print_StrCRLF(gcaNumStr);
};

// ******************
void PrintULongCRLF(uint16_t uiVal)
// ******************
{
ULongToNumStr(uiVal); Print_StrCRLF(gcaNumStr);
};



//CALCUALTION PROCEDURES
// CCCC
// ******************
long CalcDegreeIn_SMPos(float fDegree)
// ******************
{
return round( (FloatZahlenRing(fDegree, 360.0) * gfStepsPerDegree) );
};

// ******************
float CalcPostionInDegree(long lPos)
// ******************
{
// Grad * 0.54
return FloatZahlenRing( (lPos * gfDegreePerStep ), 360 );
};



// *************************************
void Set_StepMotor_Mode(uint8_t ucVal) 
//gsStMPar.u8StepMConditionFlag & STEPM_STEPMODE12_MASK
// *************************************
{ //0 = FULL_STEP 1= HALFSTEP;
//Berechne tatschliche Schritte pro Rotation
gsStMPar.ucSM_Mode = ucVal;
switch(ucVal)
	{
	case MODE_FULLSTEP :	//*1
		{//FULL 1
		//gsStMPar.ucSM_Mode = MODE_FULLSTEP;
		gpmpaStepPattern = MCA_FULLSTEPS;	//MCA pointer Adr.
		gu8ModePatternModulo = FULLSTEP_ANDPARSMAX;//4-1
		gsStMPar.uiStepsPerRotation = SM_ROTATIONS_FULLSTEPS;	//Default 100		
		
		break;
		};
	case MODE_HALFSTEP :	//*2
		{
		//gsStMPar.ucSM_Mode = MODE_HALFSTEP;
		gpmpaStepPattern = MCA_HALFSTEPS;	//MCA pointer Adr.
		gu8ModePatternModulo = HALFSTEP_ANDPARSMAX;//8-1 
		gsStMPar.uiStepsPerRotation = (SM_ROTATIONS_FULLSTEPS * 2);	//200 MODE_HALFSTEP
		break;
		};
	};
// Zahnradesektion
// UNTERSETZUNGSVERHAELTNIS(); // 40/12 = 3,333333333333
//200 * 3,333= // 666.666
gfBigWeel_FullRotCnt = gsStMPar.uiStepsPerRotation * UNTERSETZUNGSVERHAELTNIS(); // 666.666
gfStepsPerDegree =  gfBigWeel_FullRotCnt / 360.0;
gfDegreePerStep = 360.0 / gfBigWeel_FullRotCnt;
};


// *************************************
void SetMotorDirection(uint8_t ucVal)
// *************************************
{//0= Rechts  1=Linksrum
//Nur wenn nicht schon so eingestellt
//Geht nur, weil #define STEPM_DIRECTION_FLAG		0x01= NULL Bit --> Sonst Shift Bit
if(ucVal) //1 == links
	{
	gsStMPar.u8StepMConditionFlag |= STEPM_DIRECTION_FLAG;
	}
else//dir == 0 == rechts
	{
	gsStMPar.u8StepMConditionFlag &= ~STEPM_DIRECTION_FLAG;
	};
//Falls Motor grad aktiv ist,,halt in an,und ndere die Richtung		
if( gsStMPar.u8StepMConditionFlag & STEPM_RUN_FLAG ) 
	{
	StepMotorStop();
	StepMotorOn();
	};
};


// *************************************
void StepMotorOn(void)
// *************************************
{
//CPU_ICTRL_ONOFFLAG steuert ob dauerstrom oder PWM
	//Verriegelung, falls der Motor an den Anschlagschalterns steht, 
	//das er in die falsche Richtung anstartet	
	//0x10 Wert des EXtswitch via INT1 = LINKS
	//define MODE_FULLSTEP 0x00	define MODE_HALFSTEP 0x01
	//1. Warte auf Stop --> Ist der Auftrag erledigt, (verhindert widersprechnede Befehle)
	//2.Warte nach Stop
	//Set_StepMotor_Mode( gsStMPar.ucSM_Mode );		
	ICTRL_HIGHPWR();	//Lege die letzen Bits an...
	gulMovedSteps = 0;	//COUNTSZHLER !!!!!!!
	wdt_reset();   //WATCHDOG
	//Unbedingt warten damit Magnetfeld sich aufbauen und fangen kann.
	if( !(gsStMPar.u8StepMConditionFlag & STEPM_ENABLE_FLAG) )
		{		
		STEPCTRL_PORTX =  //Aktueller Stepper..Enabel
			(( STEPCTRL_PORTX ) & ~STEPAMP_ALLCTRL_MASK)	| //ODER . clear SMbit und erhalte alle anderen Bits	
			(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + gu8StepBitMusterPars) ) );		
		};	
	wdt_reset();
	_delay_ms( 1 );	//Unbedingt warten damit Magnetfeld sich aufbauen und fangen kann.
	
	//3.erst dann Starte	
	gsStMPar.u8StepMConditionFlag &= ~(STEPM_STOP_ACTIVE_FLAG | STEPM_TIMEOUT_ENABLE_FLAG);	//Lsche Pausebedingung	
	gsStMPar.u8SM_PostionFlag &= ~POSITION_STOP_ON_TARGET_OK; // !u8SM_PostionFlag
	gsStatus.TargetSMPOS_Erreicht_F = 0;
	gsStMPar.u8StepMConditionFlag |= (STEPM_ENABLE_FLAG | STEPM_RUN_FLAG);//ENABLE ANZEIGEN (INTERRUPPT)UND SPEICHERN		
	
	if(	gsStatus.ScanIndexRunning_F )
		{
		Set_StepFRQ( gsStMPar.fSCan_SM_FRQ );
		}
	else
		{
		Set_StepFRQ( gsStMPar.fStepMot_FRQ );
		};
	gsStatus.SM_Running_Msg_F = 1;
	wdt_reset();
	//TIMER ON
	StepFRQ_OnOff(FRQ_ON); 
};


// *************************************
void StepMotorStop(void)	//hlt mOTOR an, ictrl/pwm,bleibt ENABLE !!
// *************************************
{
StepFRQ_OnOff(FRQ_OFF);	//0
gulSM_ToRunCnt = 0;
//ENABELD ( STROM AKTIV !!!!)
//Jetzt mit allen Flags aufrumen
STEPCTRL_PORTX =  //Aktueller Stepper..Enabel
	(( STEPCTRL_PORTX ) & ~STEPAMP_ALLCTRL_MASK)	| //ODER . clear SMbit und erhalte alle anderen Bits	
	(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + gu8StepBitMusterPars) ) );		
//KEIN ICTRL_LOWPWR();
gsStMPar.u32SMActiveStopTime = gulT2_Ticks; //Neu  
gsStMPar.u8StepMConditionFlag |= STEPM_STOP_ACTIVE_FLAG | STEPM_TIMEOUT_ENABLE_FLAG;	//Zeige Stopstatus-ENABLED an
//Nicht dauernd Stop sagen beim IDX Lauf

gsStMPar.u8StepMConditionFlag &= ~(STEPM_RUN_FLAG | STEPM_PULSE_MODE_FLAG);
gsStMPar.u8SM_PostionFlag &= ~(POSITION_STOP_ON_DISTANCE_MODE_FLAG | POSITION_STOP_ON_TARGET_MODE_FLAG);
gsStMPar.u8SM_PostionFlag |= POSITION_STOP_ON_TARGET_OK;
gsStatus.ScanIndexRunning_F = 0;
gsStatus.SMRUN_To_absoluteTarget_GradPOS_F  = 0;
gsStatus.TargetSMPOS_Erreicht_F = 1;
gsStatus.SM_NowSTOPed_Msg_F = 1; // Damit kein Text im Interrupt getriggert wird
};


// *************************************
void StepMotorOff(void)	//Komplett STOPS AND FREE axis.
// *************************************
{
StepMotorStop();
//Lsche Stopstatus
STEPCTRL_PORTX &= ~STEPAMP_ENABLE_MASK; // Lsche nur!  Enable Status
ICTRL_LOWPWR();
gsStMPar.u8StepMConditionFlag &= ~(STEPM_PULSE_MODE_FLAG | STEPM_ENABLE_FLAG | STEPM_STOP_ACTIVE_FLAG | STEPM_RUN_FLAG);
gsStatus.SMRUN_To_absoluteTarget_GradPOS_F  = 0;
gsStatus.SM_NowOFF_F = 1; // Damit kein Text im Interrupt getriggert wird
};


// *************************************
void Set_StepFRQ(float fVal)
// *************************************
{
if(fVal)
	{
	TCNT1 = 0;
	OCR1A = (uint16_t)Round( PULS_PER_SECOND_T1 / fVal ); //16^6/1024
	TCNT1 = 0;
	};
};


// *************************************
void StepFRQ_OnOff(uint8_t uOnOff)
// *************************************
{
TCCR1B = TCCR1B_CLOCKSEL_STOP;	//Stopen, damit keine geschachtelten Interrrupts passieren...
if( uOnOff )  // Im FALLE DAS FRQ = 0 MOTOR STOP !
	{
	TIMSK &= ~( _BV(OCIE1A ) | _BV(OCIE1B ) | _BV(TOIE1 ) );
	TCNT1 = 0;/* reset TCNT1 */		/* disable PWM and stuff */
	TIMSK |= _BV(OCIE1A );	//Interrupt ein
	TCCR1B = TCCR1B_CTC_MODE | TCCR1B_CLOCKSEL_CPU_1024;//Clear Timer on Compare=CTC.  MODE an OCR1A + / CLk/1024
	}
else
	{
	TIMSK &= ~_BV(OCIE1A ); 
	};
};

// CCC
/// ***************************
void Calc_Shortest_GradPos_Direction(float fBW_Target_GradPos )
// ***************************
{
//NEU BIDIR=0 UNIDIR=1 (Je Nach SET DIRECTION)
if( fBW_Target_GradPos > gfBigWeel_GradPos )
	{
	if( (fBW_Target_GradPos - gfBigWeel_GradPos)  <= 180 )
		{
		SetMotorDirection( SM_DIR_RECHTS );
		}
	else
		{
		SetMotorDirection( SM_DIR_LINKS);
		};
	}
else //fBW_Target_GradPos < gfBigWeel_GradPos
	{
	if( (gfBigWeel_GradPos - fBW_Target_GradPos ) < 180 )
		{		
		SetMotorDirection( SM_DIR_LINKS );
		}
	else
		{
		SetMotorDirection( SM_DIR_RECHTS );
		};			
	};
};



//MOPD
// ******************
void SM_Run_Puls_DIR(uint32_t ulPuls, uint8_t ucDir)
// ******************
{
StepMotorOff();
SetMotorDirection( ucDir );
gsStatus.SMRUN_To_absoluteTarget_GradPOS_F = 0;
gsStMPar.u8StepMConditionFlag |= STEPM_PULSE_MODE_FLAG;
gulMovedSteps = 0;
gulSM_ToRunCnt = ulPuls;
StepMotorOn();
};


//GOTOD
// ******************
void Run_To_SM_Absolute_GradTarget(float fBigWheel_Grad_Target )
// ******************
{
StepMotorOff();
gfBigWeel_Target_GradPos =  FloatZahlenRing( fBigWheel_Grad_Target,360.0);
//SetMotorDirection( ucDir );
Calc_Shortest_GradPos_Direction( fBigWheel_Grad_Target ); // //Round ( abs( SetMotorDirection( ucDir );
gsStMPar.u8StepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG;
gsStatus.SMRUN_To_absoluteTarget_GradPOS_F = 1;
StepMotorOn();
};



// ******************
void StartScan_SM_Index(void)
// ******************
{
StepMotorOff();
Set_StepMotor_Mode( MODE_HALFSTEP );
SetMotorDirection( SM_DIR_DEFAULT ); //SM_DIR_RECHTS
Print_PStrCRLF( PSTR("* Index_run_is_started *") );

gsStMPar.u32SM_ActiveStartTime = gulT2_Ticks;
if( READ_SENS_INDEX_ACTIVE_ISHIGH() )  // == 1// Lasche steht im Optokoppler
	{
	Set_StepFRQ( gsStMPar.fStepMot_FRQ );
	// 200*3,333 = 666.666 aber etwas weniger, also nicht ganz rum!
	Print_PStrCRLF( PSTR("Drive near Index->") );
	gsStatus.ScanIndexRunning_F = 0;

//Print_PStr(PSTR("1->")); Print_StrCRLF( ByteToBin( gsStMPar.u8StepMConditionFlag) );
		
	SM_Run_Puls_DIR(580, SM_DIR_RECHTS ); //Drehe in raus aus der Lichschranke
	gu32TimeLatch = gulT2_Ticks;
	gsStatus.TimeOut_F = 0;
	Print_CRLF_CR();
	wdt_reset();	//WATCHDOG
	do
		{		
		if( (gulT2_Ticks - gu32TimeLatch) > SM_DRIVE_FAST_TO_INDEX_TIMEOUT ) 
			{
			Print_PStr( PSTR("*") );
			_delay_ms(500);
			wdt_reset();	//WATCHDOG
			gsStatus.TimeOut_F = 1;
			};
		}while( (gsStMPar.u8StepMConditionFlag & STEPM_PULSE_MODE_FLAG) && !gsStatus.TimeOut_F );
	Print_CRLF_CR();
	StepMotorStop();
	};	
	//Mache weiter mit Suche:
gsStatus.OptoKoppler_OLD_VAL_F = READ_SENS_INDEX_ACTIVE_ISHIGH();  // Stelle auf jetzt --> sollte NULL sein
//Print_PStr(PSTR("2->")); Print_StrCRLF( ByteToBin( gsStMPar.u8StepMConditionFlag) );
gsStMPar.u8StepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG;
Print_PStrCRLF( PSTR("Wait:Suche Index") );
gu32TimeLatch = gulT2_Ticks;  // Fr TimeOut
SetMotorDirection(SM_DIR_RECHTS);
Set_StepFRQ( gsStMPar.fSCan_SM_FRQ );
//Print_PStr(PSTR("3->")); Print_StrCRLF( ByteToBin( gsStMPar.u8StepMConditionFlag) );
gsStatus.IndexOK_F = 0;
gsStatus.ScanIndexRunning_F = 1;
gu32TimeLatch = gulT2_Ticks; // jetzt nochnmal merken, damit Int bescheid wei
//Print_PStr(PSTR("4->")); Print_StrCRLF( ByteToBin( gsStMPar.u8StepMConditionFlag) );
StepMotorOn();
//Print_PStr(PSTR("5->")); Print_StrCRLF( ByteToBin( gsStMPar.u8StepMConditionFlag) );
};


// ******************
void ResetRxBuff(void)
// ******************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};

// ******************
void UART_TXRX_Check(void)
// ******************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if ( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#if UART_ERRORMSG == 1
	if ( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCRLF(  PSTR("UARTError") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 10 : // LF
				{
				return;
				break;
				};
			case 13: // order!! from Terminal
				{
#if MSG == 1
//Print_StrCRLF(gcaRxStr);
#endif
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};

// OOO
// ******************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// ******************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"

#ifdef DEGREE_FUNCTIONS_ENABLED
//uint16_t uiCnt =0;
#endif

char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
#if LCD_4Bit_Module_USED == 1
WriteLCD(LCD_SHOW_CMD_LINE, gcaStr);//Fllt mit Sapce auf Vorsicht umkopieren..	//ZEIGE DAs Commando an
#endif
// Print_StrCRLF( pcStrOrder );  /Rausmachen da zuvile Trffic dabei entsteht.

/*
int8_t caCmd[COMAMNDSIZEMAX +1];
	uint8_t ucCmdID;
	float fCmdVal_1;
	float fCmdVal_2;
*/

// SETZE "," in gcaNumStr als RAMVARIABLE fr Delimiter.
strcpy_P(gcaNumStr, MCA_DELIMITER_MSG); //HILFSWEISE gcaNumStr fr ","
if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr , &pucCh)) != NULL) //Trenne CMD, CMD
	{	
	strcpy(gsCmd.caCmd, pStrTok);
	}
else
	{
	*gsCmd.caCmd = 0;
	};

gsCmd.caCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)//Hole nun einen Value nach "$$$1,COMMAND,VALUE
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================

if( !strcasecmp_P( gsCmd.caCmd, PSTR("PING") ) ) 
	{ 
	Print_PStrCRLF( PSTR("PONG - DrehFilter") ); return;
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("VER") ) ) 	
	{ 
	Print_PStr( PSTR( DATUM ) );
	Print_PStrCRLF( PSTR(" by Christof Ermer (C)Universitaet Regensburg") ); return;
	return;
	};
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SCI") ) ) 
	{
	StartScan_SM_Index();
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("SIX" ) ) ) 	//Set INDEX gegenwrtige Position direkt eingestellt
	{
	gsStatus.ScanIndexRunning_F = 0;
	gsStatus.IndexOK_F = 1;
	gsStatus.NewIndexFound_F = 1;
	gfBigWeel_GradPos = 0;	
	glSM_RotPosition = 0;
	gfBigWeel_FullRotCnt = 0;
	return;
	};


if( !strcasecmp_P( gsCmd.caCmd, PSTR("GIDX") ) )
	{ 
	PrintULongCRLF( gsStatus.IndexOK_F); return;
	};
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("GOTOD" ) ) )   //Goto DEGREE
	{
	Run_To_SM_Absolute_GradTarget( FloatZahlenRing( (gsCmd.fCmdVal_1 + gsStMPar.iIndexOffset), 360.0 ) );
	StepMotorOn();
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("TAR_OK?" ) ) )  //Target_Erreicht_F = 1
	{
	PrintLongCRLF( gsStatus.TargetSMPOS_Erreicht_F ); return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("GPOS" ) ) )
	{	
	PrintLongCRLF( glSM_RotPosition );	 return;
	};	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("BWGP" ) ) )
	{	
	PrintFloatCRLF( gfBigWeel_GradPos ); return;
	};	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("BWTP" ) ) )
	{	
	PrintFloatCRLF( gfBigWeel_Target_GradPos  ); return;
	};	
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SMON") ) )
	{
	gsStMPar.u8StepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG; //Kein Pulscount
	gsStatus.SMRUN_To_absoluteTarget_GradPOS_F = 0;
	if((uint8_t)gsCmd.fCmdVal_1)	//OPTIONAL; GLEICH MIT pULScountangabe
		{
		gsStMPar.fStepMot_FRQ = gsCmd.fCmdVal_1;		
		}
	else
		{
		gsStMPar.fStepMot_FRQ  = PREDEF_STEPFREQUENZ;
		};
	Set_StepFRQ( gsStMPar.fStepMot_FRQ );
	StepMotorOn();
	};

//MOPD
if( !strcasecmp_P( gsCmd.caCmd, PSTR("MOPD") ) ) //MOTOr ON Pulse, Direction
	{
	SM_Run_Puls_DIR( (uint32_t)gsCmd.fCmdVal_1, (uint8_t)gsCmd.fCmdVal_2 );	//Default ist 200...
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("SMOFF") ) )
	{
	StepMotorOff();
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("SMSTOP") ) )
	{
	StepMotorStop();
	};
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SFR") ) )
   {
	if( gsCmd.fCmdVal_1 )
		{ gsStMPar.fStepMot_FRQ = gsCmd.fCmdVal_1; }
	else
		{ gsStMPar.fStepMot_FRQ = PREDEF_STEPFREQUENZ;	};	
	Set_StepFRQ( gsStMPar.fStepMot_FRQ );
	};

	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SDIR") ) )
   {
	if((uint8_t)gsCmd.fCmdVal_1)
		{
		SetMotorDirection( SM_DIR_LINKS );
		}
	else
		{
		SetMotorDirection( SM_DIR_RECHTS );
		};
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("HALF") ) )
	{	
	Set_StepMotor_Mode( MODE_HALFSTEP ); //2
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("FULL") ) )
	{
	Set_StepMotor_Mode(  MODE_FULLSTEP );	//1
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("SIDXFRQ") ) )    //SET INDEX SCAN FRQ
   {
	if( gsCmd.fCmdVal_1 )
		{gsStMPar.fSCan_SM_FRQ = gsCmd.fCmdVal_1; }
	else
		{ gsStMPar.fSCan_SM_FRQ = PREDEF_SCAN_INDEX_FRQ;	};	//Default 25.0
	return;
	};
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SPR") ) ) //Set Steps per Rotation
	{	//Default ist 200...
	gsStMPar.u16SM_HardwareBasisSteps = (uint16_t)gsCmd.fCmdVal_1; //Normal 200
	return;
	};
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SETO") ) ) //Set ENBALE TIMEOUT if Stop
	{	
	gsStMPar.ulStepM_Enable_TimeOut = (uint32_t)gsCmd.fCmdVal_1;
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("SIT") )  ) 
	{
	gsStMPar.uiScan_Index_Timeout = (uint16_t)gsCmd.fCmdVal_1;
	return;
	};
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SIENA") )  ) 
	{
	if( (uint16_t)gsCmd.fCmdVal_1)
		{
		gsStatus.ScanIDX_Start_EnaF = 1;
		}
	else
		{
		gsStatus.ScanIDX_Start_EnaF = 0;
		};
	return;
	};


if( !strcasecmp_P( gsCmd.caCmd, PSTR("IDXO" ) ) ) //indexOffset direkt eingestellt
	{
	gsStMPar.iIndexOffset = (int16_t)gsCmd.fCmdVal_1;
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("COF") ) )
	{
	PrintLongCRLF( gsStMPar.u8StepMConditionFlag );  return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("COFBIN") ) )
	{
	Print_StrCRLF( ByteToBin( gsStMPar.u8StepMConditionFlag ) ); return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("POF" ) ) )    //
	{
	PrintLongCRLF(gsStMPar.u8SM_PostionFlag); return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("POFBIN") ) )
	{
	Print_StrCRLF( ByteToBin( gsStMPar.u8SM_PostionFlag) ); return;
	};
// ..............................................

if( !strcasecmp_P( gsCmd.caCmd, PSTR("BWFR" ) ) )
	{	
	PrintFloatCRLF( gfBigWeel_FullRotCnt ); return;
	};	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("SPD" ) ) )
	{	
	PrintFloatCRLF( gfStepsPerDegree ); return;
	};	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("DPS" ) ) )
	{	
	PrintFloatCRLF( gfDegreePerStep );	 return;
	};	

	 
if( !strcasecmp_P( gsCmd.caCmd, PSTR("CPOSID" ) ) ) // TX PositionDefg
	{	
	PrintFloatCRLF( CalcPostionInDegree( gsCmd.fCmdVal_1 ) ); return;
	};	

if( !strcasecmp_P( gsCmd.caCmd, PSTR("CDISMPOS" ) ) ) // TX PositionDefg
	{	
	PrintLongCRLF( CalcDegreeIn_SMPos( gsCmd.fCmdVal_1 ) ); return;
	};	

if( !strcasecmp_P( gsCmd.caCmd, PSTR("LICHTSCHRANKE" ) ) ) // TX PositionDefg
	{	
	PrintLongCRLF( gsStatus.OptoKopplerActive_F );
	return;
	};	

// ***************************
	if( !strcasecmp_P( gsCmd.caCmd, PSTR("Flags") ) )    //0= CR ONLY, 1 = CRLF
	{
	Print_PStr(PSTR("ScanIDXStart?->"));PrintLongCRLF( (int)gsStatus.ScanIDX_Start_EnaF );
	Print_PStr(PSTR("ScanIndexRunning_F?->"));PrintLongCRLF( gsStatus.ScanIndexRunning_F );
	Print_PStr(PSTR("NewIndexFound_F?->"));PrintLongCRLF( gsStatus.NewIndexFound_F);
	Print_PStr(PSTR("IDXOK?->"));PrintLongCRLF( gsStatus.IndexOK_F );
	Print_PStr(PSTR("OptoKopplerActive_F?->"));PrintLongCRLF( gsStatus.OptoKopplerActive_F );
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("POS") ) )
	{ 
	Print_PStr(PSTR("gfBigWeel_FullRotCnt=\t"));PrintFloatCRLF( gfBigWeel_FullRotCnt );
	Print_PStr(PSTR("gfStepsPerDegree=\t"));PrintFloatCRLF( gfStepsPerDegree );
	Print_PStr(PSTR("gfBigWeel_GradPos=\t"));PrintFloatCRLF( gfBigWeel_GradPos );
	Print_PStr(PSTR("glSM_RotPosition=\t"));PrintULongCRLF(glSM_RotPosition );
	Print_PStr(PSTR("gfBigWeel_TargetPos=\t"));	PrintFloatCRLF(gfBigWeel_Target_GradPos  );
	Print_PStr(PSTR("Target_Erreicht_F=\t")); PrintLongCRLF( gsStatus.TargetSMPOS_Erreicht_F );
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("TRX" ) ) )  //& TZRAFFIC ON
	{
	gsStatus.ComTraffic_F =  (uint8_t)gsCmd.fCmdVal_1;
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("CR_CRLF" ) ) )    //0= CR ONLY, 1 = CRLF
	{
	gsStatus.CRLF_CR_F = (uint8_t)gsCmd.fCmdVal_1;
	return;
	};
	
if( !strcasecmp_P( gsCmd.caCmd, PSTR("IDXCHANGE" ) ) ) 
	{
	gsStatus.OptoKoppler_OLD_VAL_F = gsStatus.OptoKopplerActive_F;
	
	Print_PStr( PSTR("IDXChange=") );
	Print_Str( ULongToNumStr( gsStatus.OptoKopplerActive_F ) );
	Print_PStr( PSTR(" = ") );
	PrintULongCRLF( READ_SENS_INDEX_ACTIVE_ISHIGH() );			
	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("TT" ) ) )
	{
	PrintULongCRLF( gulT2_Ticks );	return;
	};

if( !strcasecmp_P( gsCmd.caCmd, PSTR("??") ) )
	{ 
	Print_PStr( PSTR("SCI,GIDX,GOTOD,TAR_OK?SIX,TRX,GIDX,IDXO") );
	Print_PStr( PSTR("SMON,MOPD,SMSTOP,SMSOFF,SFR,SDIR") );
	Print_PStr( PSTR("HALF,FULL,SPR,SIENA,SIX,SIDXFRQ,SETO,SIT") );
	Print_PStr( PSTR("SPO,SDP,GOD,COF,COFBIN,POF,POFBIN,POS,SIENA") );
	Print_PStr( PSTR("BWFR,SPD,DPS,GPOS,BWGP,BWTP,CPOSID,CDISMPOS") );
	Print_PStr( PSTR("LICHTSCHRANKE,IDXCHANGE,Flags,Ping,VER,CR_CRLF,TRX,TT") );
	return;
	};
	
#if CMD_OK_ECHO_ENABLED == 1

if( gsStatus.ComTraffic_F )
	{
	strcpy_P(gcaStr, PSTR("CMD:") );
	strcat(gcaStr, gsCmd.caCmd);
	strcat_P(gcaStr,MCA_DELIMITER_MSG);
	strcat(gcaStr, FloatToNumStr(gsCmd.fCmdVal_1) ); 
	strcat_P(gcaStr, MCA_SPACE_MSG);
	if( gsStatus.CRLF_CR_F )
		{
		strcat_P(gcaStr, MCA_OK_MSG );   
		}
	else
		{
		strcat_P(gcaStr, MCA_OK_MSG );   
		};
	Print_StrCRLF(gcaStr);   
	};
#endif
};//ENDE ORDER FUNC.


//MM
// ************ MAIN LOOP FOR EVER *********************
 int main(void)
// **********************************************************
{
uint32_t ulMainCnt = 0; //Speed watch 
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//INITS
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS   like --->
DDRA = PORTA_OUTMASK;
PORTA = PORTA_PULLMASK; //=0
DDRB = PORTB_OUTMASK;
PORTB = PORTB_PULLMASK; //#define PORTB_PULLMASK 0x00 //Nothing PullUp
DDRC = PORTC_OUTMASK;	//DIREKT IN geppult ?
PORTC = PORTC_PULLMASK; //#define PORTC_PULLMASK 0x00 //
DDRD = PORTD_OUTMASK;	//1100 0010 #define PORTD_OUTMASK 0xC2	//DDRB = PORTD_OUTMAS;
PORTD = PORTD_PULLMASK;	//#define PORTD_PULLMASK 0x01

ICTRL_LOWPWR();

ResetRxBuff();
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
gsStatus.CRLF_CR_F = CR_ODER_CRLF_DEFAULT;  //= 1 CRLF


gsStMPar.fStepMot_FRQ = PREDEF_STEPFREQUENZ;		//Default 100.0
gsStMPar.fSCan_SM_FRQ = PREDEF_SCAN_INDEX_FRQ;		//Default 25.0

gsStMPar.ucSM_Mode = PREDDEF_STEPMODE;				//MODE_HALFSTEP
gsStMPar.ulStepM_Enable_TimeOut = PREDEF_STEPM_ENABLE_TIMEOUT_SEC; // 610 // 10.0 SEc. / TIMER2_INTPERIODE (if ENABLED !!)
//gsStMPar.ulMotorRunTime = PREDEF_MOTOR_RUN_TIME; //0xFFFFFFFF = Allways
gulSM_ToRunCnt = PREDEF_STEPCLOCKS;//= 1 wieviele Steps soll der Motor gehen(Default= 1)
gsStMPar.u16SM_HardwareBasisSteps = SM_ROTATIONS_FULLSTEPS;	//Default 100  half steps

gsStMPar.uiStepsPerRotation = gsStMPar.u16SM_HardwareBasisSteps * gsStMPar.ucSM_Mode;
//gsStMPar.u8StepMConditionFlag & STEPM_BIDIRECTION_FLAG  = PREDEF_BIDIRECTION_MODE;
//gsStMPar.u8StepMConditionFlag = STEPM_BIDIRECTION_FLAG;	//Setze auf UNIDIR=1(Je NAch SET DIRECTION)

gsStMPar.uiScan_Index_Timeout = PREDEF_SCANINDEX_TIMEOUT;			//	4800 60 ~ 80 Sekunden
gsStMPar.iIndexOffset = PREDEF_INDEX_OFFFSET;	//#define PREDEF_INDEX_OFFFSET


//VARIABLEN lschen
glSM_RotPosition = 0;
gu8StepBitMusterPars = 0;
gsStMPar.u32SMActiveStopTime = 0;

sei();
Print_PStrCRLF( PSTR("**Neustart erfolgreich**" ) );
_delay_ms(50 );
wdt_reset();	//WATCHDOG

StepMotorOff();//Flags setzen
Set_StepMotor_Mode( MODE_HALFSTEP ); //MODE_FULLSTEP
SetMotorDirection( SM_DIR_DEFAULT ); //SM_DIR_RECHTS

//UNTERSETZUNGSVERHAELTNIS(); //3,3333333
//((float)((float)ZAHNRAD_GROSS / (float)ZAHNRAD_KLEIN)) //3,333333

wdt_reset();	//WATCHDOG
Print_PStrCRLF( PSTR("I have no brain") ) ;
Print_PStrCRLF( PSTR("use your own!") );
_delay_ms(100 );
//includes ucSM_Mode und gsStMPar.uiStepsPerRotation
//HALFSTEP; RAMPE = ON; TIMEOUT IF ACTIVE STOP AND ENABLED
//STEPM_DIRECTION_FLAG 0 = RECHTS_VOREINGESTELLT
//ZEROS
//MM
gsStatus.CRLF_CR_F =  CR_ODER_CRLF_DEFAULT;
gsStatus.ComTraffic_F  = 0;

wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();	//WATCHDOG

StartTimer2();	//8 Bit Timer 2 = MS Tick 
sei();

gsStatus.ScanIDX_Start_EnaF = SCAN_IDX_BY_START_DEFAULT;

if( gsStatus.ScanIDX_Start_EnaF )
	{
	StartScan_SM_Index(); // Trigger Scan
	};

gsStMPar.u8SM_PostionFlag &= ~POSITION_STOP_ON_TARGET_OK;

for (;;)  /* loop forever */
   {
//@@@	
	wdt_reset();	//WATCHDOG
	ulMainCnt++;
// SEKUNDE TICKS
	if( gsStatus.TickEvent_F )	//SEKUNDEN PULS EVENT. in main loop
		{
		gsStatus.TickEvent_F = 0;
		LongToNumStr(ulMainCnt);
		ulMainCnt=0;
		
		if( gsStatus.ComTraffic_F )
			{
			Print_CRLF_CR();
			Print_StrCRLF( gcaNumStr);  //MainCount			
			
				//Check Enable TImeout.		
			if(	!(gsStMPar.u8StepMConditionFlag & STEPM_RUN_FLAG) && //0 =Aktiv. Timeoutcheck = 0 KEIN TIMEOUT=allways ON 
				(gsStMPar.u8StepMConditionFlag & STEPM_STOP_ACTIVE_FLAG)	&&
				(gsStMPar.u8StepMConditionFlag & STEPM_TIMEOUT_ENABLE_FLAG)	&&
				( (gulT2_Ticks - gsStMPar.u32SMActiveStopTime) > gsStMPar.ulStepM_Enable_TimeOut)
			)
				{
				//Bits belassen, 
				ICTRL_LOWPWR();
				gsStMPar.u8StepMConditionFlag &= ~STEPM_TIMEOUT_ENABLE_FLAG;
				Print_PStrCRLF( PSTR( "I_PWR_OFF cause TimeOut" ) );
				};			
					
			if( gsStatus.NewIndexFound_F )
				{
				gsStatus.NewIndexFound_F = 0;
				Print_PStrCRLF(PSTR("New INDEX Found" ) );
				( gsStatus.IndexOK_F  ? Print_PStr(PSTR("OK")) : Print_PStr(PSTR("Wrong")) );
				};
				
			if( gsStatus.TimeOut_F )
				{
				gsStatus.TimeOut_F =0;
				Print_PStrCRLF(PSTR("TIME OUT") );	
				Print_PStr(PSTR("Index=") );	
				};

			if(!gsStatus.IndexOK_F) Print_PStrCRLF( PSTR("IDX Wrong"));
			strcpy_P(gcaStr, PSTR("WeelPos:") );
			strcat_P(gcaStr, MCA_ISTGLEICH_MSG);
			strcat(gcaStr, FloatToNumStr( gfBigWeel_GradPos ) );
			strcat_P(gcaStr, MCA_SPACE_MSG);

			strcat_P(gcaStr, PSTR("TargetPos:") );
			strcat_P(gcaStr, MCA_ISTGLEICH_MSG);
			strcat(gcaStr, FloatToNumStr( gfBigWeel_Target_GradPos  ) );
			strcat_P(gcaStr, MCA_SPACE_MSG);
			Print_StrCRLF(gcaStr);
			
			
	Print_PStr(PSTR("gfBigWeel_FullRotCnt=\t"));PrintFloatCRLF( gfBigWeel_FullRotCnt );
	Print_PStr(PSTR("gfStepsPerDegree=\t"));PrintFloatCRLF( gfStepsPerDegree );
	Print_PStr(PSTR("gfDegreePerStep=\t"));PrintFloatCRLF( gfDegreePerStep );
	Print_PStr(PSTR("glSM_RotPosition=\t"));PrintULongCRLF(glSM_RotPosition );
	Print_PStr(PSTR("gfBigWeel_GradPos=\t"));PrintFloatCRLF( gfBigWeel_GradPos );
	Print_PStr(PSTR("gfBigWeel_Target_GradPos=\t"));	PrintFloatCRLF(gfBigWeel_Target_GradPos  );
				
			};	//COM TRAFFIC
		};	// ENDE SEKUNDETICKS

	if(	gsStatus.SM_Running_Msg_F )
		{
		gsStatus.SM_Running_Msg_F = 0;
		if( gsStatus.ComTraffic_F )
			{
			Print_PStr( MCA_MOTOR_MSG );
			Print_PStrCRLF( PSTR( " RUNNING")  );
			};
		};

	if( gsStatus.SM_NowSTOPed_Msg_F ) //Damit kein Text im Interrupt getriggert wird
		{
		gsStatus.SM_NowSTOPed_Msg_F = 0;
		if( gsStatus.ComTraffic_F )
			{
			Print_PStr( MCA_MOTOR_MSG );
			Print_PStrCRLF( PSTR( " STOP")  );
			};
		}; 
		
	if( gsStatus.SM_NowOFF_F ) // Damit kein Text im Interrupt getriggert wird
		{
		gsStatus.SM_NowOFF_F = 0;
		if( gsStatus.ComTraffic_F )
			{
			Print_PStr( MCA_MOTOR_MSG );
			Print_PStrCRLF( PSTR( " OFF") );
			};			
		};
		
	//SCAN				
	if(  !gsStatus.ScanIndexRunning_F && //Wenn nicht gerade gesucht wird
		(gsStatus.OptoKopplerActive_F != gsStatus.OptoKoppler_OLD_VAL_F	)
	)
		{
		gsStatus.OptoKoppler_OLD_VAL_F = gsStatus.OptoKopplerActive_F;

		if( gsStatus.ComTraffic_F )
			{		
			Print_PStr( PSTR("IDXChange=") );
			Print_Str( ULongToNumStr( gsStatus.OptoKopplerActive_F ) );
			Print_PStr( PSTR(" =\t ") );
			PrintULongCRLF( READ_SENS_INDEX_ACTIVE_ISHIGH() );	
			};
		};
								
	if( gsStMPar.u8SM_PostionFlag & POSITION_STOP_ON_TARGET_OK )
		{
		gsStatus.TargetSMPOS_Erreicht_F = 1;
		gsStMPar.u8SM_PostionFlag &= ~POSITION_STOP_ON_TARGET_OK;	
		if( gsStatus.ComTraffic_F )
			{
			strcpy_P(gcaStr, PSTR("TARGET") );
			strcat_P(gcaStr, MCA_ISTGLEICH_MSG);
			FloatToNumStr(gfBigWeel_Target_GradPos );
			strcat(gcaStr, gcaNumStr);
			Print_StrCRLF( gcaStr );
			};
		};

	//Read and Service UART	
	if( !(gulT2_Ticks & 0x1F )) {UART_TXRX_Check();}; //IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN

	}; // main   END END *************
};
// ******************* MAIN END ********************************************
