
// Neu Bearbeitet 12.09.24
/*
INSTITUT	"UNI-Regensburg"
AUTOR		"Christof Ermer"
DATUM		12.09.2024 //"15.3.2007"
*/

#ifndef MAIN_HEADER  //Prevents multiple includes
#define MAIN_HEADER

//#define USE_DEBUGMSG
#define CR_ODER_CRLF_DEFAULT		0	//0 = CR ONLY 1=CRLF->gsStatus.CRLF_CR_F
#define UART_ERRORMSG				1
//#define MSG						0
//Timeout von LCD wird simuliert
#define COM_TX_ENABLED				1

#define DEGREE_FUNCTIONS_ENABLED		

#define SCAN_IDX_BY_START_DEFAULT		0  // 1
#define ZAHNRADGETRIEBE_VORHANDEN		1
#define MSG_SUPPRESS_DIRECTIVE			0 //1= unterdrcke zuviel Traffic in der Ausgabe
#define MSG_STOP_ENABLED				0
#define CMD_OK_ECHO_ENABLED				1
#define MSG_SUPPRESS_DIRECTIVE			0

#define FLOAT_PRAEDIGITS_MAX	5 // DIgits vor   /dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define FLOAT_DIGITS_MAX		3 // DIgits nach //dtostrf(fVal,NUMMAX, DIGITS_MAX, gcaNumStr);
#define ASC_CR	13
#define ASC_LF	10

//COMMAND
#define DELIMITER		','
#define DELIMITERSTR	","
#define COMAMNDSIZEMAX  20



/*
IF ( ? : );
const char MCA_CRSTR[] PROGMEM = {13,0};
const char MCA_CRLFSTR[] PROGMEM = {13,10,0};
const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };
const char MCA_DELIMITER_MSG[] PROGMEM	= ",";
const char MCA_DPOINT_MSG[] PROGMEM = ":";
const char  MCA_SPACE_MSG[] PROGMEM	= " ";
*/

typedef struct
{
uint8_t IndexOK_F : 1; // gsStatus.IndexOK_F
uint8_t TargetSMPOS_Erreicht_F : 1;	//gsStatus.TargetSMPOS_Erreicht_F
uint8_t SMRUN_To_absoluteTarget_GradPOS_F : 1;	//gsStatus.SMRUN_To_absoluteTarget_GradPOS_F
uint8_t SM_NowSTOPed_Msg_F : 1; // gsStatus.SM_NowSTOPed_Msg_F  // Damit kein Text im Interrupt getriggert wird
uint8_t SM_Running_Msg_F : 1; // gsStatus.SM_Running_Msg_F  // Damit kein Text im Interrupt getriggert wird
uint8_t SM_NowOFF_F : 1; // gsStatus.SM_NowOFF_F  // Damit kein Text im Interrupt getriggert wird

uint8_t ScanIDX_Start_EnaF : 1; // gsStatus.ScanIDX_Start_EnaF
uint8_t ScanIndexRunning_F : 1; // gsStatus.ScanIndexRunning_F
uint8_t OptoKopplerActive_F : 1;	//gsStatus.OptoKopplerActive_F
uint8_t OptoKoppler_OLD_VAL_F : 1;	//gsStatus.OptoKoppler_OLD_VAL_F
uint8_t NewIndexFound_F : 1; // gsStatus.NewIndexFound_F
uint8_t TimeOut_F : 1;	//gsStatus.TimeOut_F
uint8_t TickEvent_F : 1; // gsStatus.TickEvent_F
uint8_t ComTraffic_F : 1; // gsStatus.ComTraffic_F
uint8_t CRLF_CR_F : 1;	//gsStatus.CRLF_CR_F
}STATUS_TYPE;
// gsStatus.

#define TICKS_PER_SECOND	250
#define SM_STEP_TIMEOUT (TICKS_PER_SECOND*3)
#define SM_DRIVE_FAST_TO_INDEX_TIMEOUT (TICKS_PER_SECOND *10)  //30
#define SM_IDX_SCAN_TIMEOUT (TICKS_PER_SECOND *40)  //30



//in STRUCT STEPMPARTYPE;
//#define STEPM_RAMPE_FLAG			0x04	// MIT_RAMPE, ?
//#define STEPM_START_RAMPE_FLAG		0x08	// 0 = Selected Counts, 1 = Countinous

//Flags
#define POSITION_STOP_ON_TARGET_MODE_FLAG	0x01	
#define POSITION_STOP_ON_TARGET_OK			0x02	
#define POSITION_STOP_ON_DISTANCE_MODE_FLAG	0x04	
#define POSITION_STOP_ON_DISTANCE_OK		0x08	
//gsStMPar.u8SM_PostionFlag

#define STEPM_RUN_FLAG				0x01	//Ohne RemainTime Zurcksetzung Run=Continue condtition
#define STEPM_ENABLE_FLAG			0x02	// 0 = OFF
#define STEPM_PULSE_MODE_FLAG		0x04	// 0 = OFF
#define STEPM_STOP_ACTIVE_FLAG		0x08	//STOP, BUT ENABLED, (STROM ON!!) Absicht!!, STEMotor StoptMode ..mit ICTRL, SPTER PWM, oder Automatische Disable nach Timeout.
#define STEPM_DIRECTION_FLAG		0x10	//Syncron zu  SM_DIR_LINKS/rechts d 0 = rechts ?? unbestimmt je nach verdrahtung
#define STEPM_TIMEOUT_ENABLE_FLAG	0x20	//After Stop Auto Disable after TIMEOUT
//	gsStMPar.u8StepMConditionFlag;	//ISTZUSTAND

//TYPEN DEKLARATION
typedef struct
	{
	float fStepMot_FRQ;	
	float fSCan_SM_FRQ;		
//	float fRampeFrq;		//Wird incrementiert bis == gsStMPar.fStepMot_FRQ fr Rampe
	
	uint8_t ucSM_Mode;	//Full=1 Half  = 2
	uint16_t u16SM_HardwareBasisSteps; //=PREFDEF_STEPS_PER_ROTATION
	uint16_t uiStepsPerRotation; //200 ucSM_Mode * u16SM_HardwareBasisSteps=PREFDEF_STEPS_PER_ROTATION= 	
	int16_t iIndexOffset;
	uint32_t ulStepM_Enable_TimeOut;	//Nach zu langer Stopzeit--Auto Timeout Release (Hitzeschutz)
	uint16_t uiScan_Index_Timeout;
	uint32_t u32SM_ActiveStartTime;
	uint32_t u32SMActiveStopTime;
	uint8_t u8StepMConditionFlag;	//ISTZUSTAND
	uint8_t u8SM_PostionFlag;
	//uint8_t ucCPUModeFlag;		//COM OUT enabled etc....
	//uint8_t ucSysModeFlag;	
	//uint16_t uiScan_Index_Timeout;
		
}STEPMPARTYPE;	//gsStMPar.



typedef struct
	{
	char caCmd[COMAMNDSIZEMAX +1];
	float fCmdVal_1;
	float fCmdVal_2;
	}COMMAND_TYPE;	//gsCmd

/*
typedef struct	//Bisher unbenutzt
	{
	uint8_t ucMenueLevel;
	uint8_t ucMenueFlag;
	}Menue_Type;
*/


//MECHANIK
#define ZAHNRAD_GROSS		40 //Zhne ?Mit Kommma wegen float type
#define ZAHNRAD_KLEIN		12 //Zhne ?Mit Kommma wegen float type
#define UNTERSETZUNGSVERHAELTNIS()	((float)((float)ZAHNRAD_GROSS / (float)ZAHNRAD_KLEIN)) //3,3333333333333333333333333333333
#define FULLROT_DEGREE_360		360.0	//muss float sein


#define FULLSTEP_ANDPARSMAX 3	//& 4-1
#define HALFSTEP_ANDPARSMAX 7  //& 8-1	
#define MODE_FULLSTEP	1	//Multiplikator 1X. gsStMPar.u8StepMConditionFlag |=  MODE_FULLSTEP
#define MODE_HALFSTEP 	2	//Multiplikator 2X. Set_StepMotor_Mode(gsStMPar.u8StepMConditionFlag & STEPM_STEPMODE_)

#define SM_ROTATIONS_FULLSTEPS	100 //FULLSTEP ( Ein ziemlch grober Motor )
#define SM_ROTATIONS_HALFSTEPS	200 //
//#define SM_ROTATIONS_FULLSTEPS	200 //FULLSTEP ( Ein ziemlch grober Motor )
//#define SM_ROTATIONS_HALFSTEPS	400 //

// Hardwareassignment
//#define XTAL_CPU           16000000UL	/* 16Mhz */
//F_CPU  in makefile !!!
#define UART_BAUD_RATE     9600			/* 9600 baud */
//F_CPU/1024 = 15625 Counts/Sec  !!!!
#define PULS_PER_SECOND_T1	15625  // 16^6 / 1024 = 15625
#define Time_Per_count_T1	0.000064		//  1/15625

//ICTRL via  BUZ11 wird ein Widerstand (2*4R7) Kurzgeschlossen was ON bedeuted
#define ICTRL_DDRX	DDRD
#define ICTRL_PORT	PORTD
#define ICTRL_PIN	_BV(PD6)
#define ICTRL_HIGHPWR()	(ICTRL_PORT |= ICTRL_PIN)
#define ICTRL_LOWPWR()	(ICTRL_PORT &= ~ICTRL_PIN)

//PORT_ASSIGMNEMTS
//#define ADC_PORT		PORTA
#define STEPCTRL_PORTX		PORTA
#define STEPAMP_ALLCTRL_MASK	0x3F	//0011 1111
#define STEPAMP_CTRL_MASK		0x0F	//0000 1111
#define STEPAMP_ENABLE_MASK		0x30	//0011 0000

// NEUE HARDWARE DEFINITIONEN
#define SENS_PORT_IN			PINC
#define SENS_OPTOKOPPLER_IDX	_BV(PC0) //PC0 0x01 bitmask
//MAKROS
#define READ_SENS_INDEX_ACTIVE_ISHIGH() (SENS_PORT_IN & SENS_OPTOKOPPLER_IDX)

//1=OUT  1011 1111 0x00
//1=pullup 0x0001 1000  
//PORT A
#define PORTA_OUTMASK STEPAMP_ALLCTRL_MASK
#define PORTA_PULLMASK 0x00
//#define 

//PORT B
///( 1=OUT ) 0000 1000 = 0x08
#define PORTB_OUTMASK 0b01111111  //1111 1111	//ULN2803
#define PORTB_PULLMASK 0x00 //Nothing PullUp Vpr allem LCD Dat 7 = PB3 = LOW

//PORT C   //STEPAMPLIFIERE 
#define PORTC_OUTMASK	0// ALLES IN
#define PORTC_PULLMASK	0

//PORT D
#define PORTD_OUTMASK  0b01000010  // ICTRL_PIN
#define PORTD_PULLMASK 0b10111101

// -------------------------------

#define TCCR0_FAST_PWM	0x48	//Mode 3
#define TCCR0_OC0_MODE	0x20	//Clear ON compare Match
#define TCCR0_OC0_DISCONNECT_MODE	0x00
#define TCCR0_CLK_1024	0x05	//~61,035 PWM
#define TCCR0_CLK_256	( _BV( CS22 ) | _BV( CS21 ) )	//244,14Hz PWM
#define TCCR0_CLK_64		0x03	//976,56Hz PWM
#define TCCR0_CLK_8		0x02	//7812 Hz PWM
#define TCCR0_CLK_0		0x01	//62500 PWM
#define TCCR0_CLK_STOP	0x00	


//MODUS COMAPARE 250 = 250/Sec
#define TCCR2_WGM_NORMAL	0x00
#define TCCR2_CTC_MODE		0x08 //0000 1000
#define TCCR2_COM_NORMALPORT	0x00
#define TCCR2_CLK_1024		( _BV(CS22) | _BV(CS21) | _BV(CS20) )
#define TCCR2_CLK_256		( _BV(CS22) | _BV(CS21) )
#define TCCR2_CLK_STOP		0x00
#define TCCR2_FASTPWM		0x48	//Mode 3
#define TCCR2_CS_BIST		0x0x	//Mode 3

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CTC_MODE				0x08	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits


//PORTB 
#define MOSI_I         5//BIT5
#define MISO_0         6//BIT6
#define SCK_I          7//BIT7

//#define TCCR1B_CLOCKSEL_CTC1 		0x08	//Clear Timer/Counter  on Compare Match Timer/Counter 1
#define TCCR1B_CLOCKSEL_STOP		0x00	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1		0x01	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_8		0x02	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_64		0x03	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_256		0x04	//Clock Select Bits
#define TCCR1B_CLOCKSEL_CPU_1024	0x05	//Clock Select Bits
//-----------------------

//TIMERS
//TIMER2  = is 61 miliseconds Timer ~approx.
// 16MhZ / 1024 / 256  = 61,03515625 Hz
// T= 1/f = 0.016384 ms / Interrupt
#define TIMER2_INT_FREQUENCY	250
#define ONE_SECOND_TICKS		250	//1/ TIMER2_INTPERIODE
#define LONG_10DELAY_TICKS		2500	//1/ TIMER2_INTPERIODE
#define SM_AFTERSTOPDELAY_TICKS 4  // 1000/250= 4= 1ms

//MASKENBITS
//INTERRUPT
#define INTx_INPORT	PIND
//#define INT1_MASK	0x08  //PD3
//#define INT0_MASK	0x04  //PD2
#define INT0_PIN_NR	PD2
//#define INT1_PIN_NR	PD3


#define WDTO_2S   7 //WatchDog

//DEFAULTS
//Depends on MotorType
//#defie ANGLE_PER_STEP 1.8  //(360/PREFDEF_STEPS_PER_ROTATION) //DEFAULT
//#defie ANGLE_PER_STEP 3.6  //(360/PREFDEF_STEPS_PER_ROTATION) //DEFAULT

#define PREDDEF_STEPMODE		MODE_HALFSTEP  //MODE_HALFSTEP
#define PREDEF_LOW_SPEED 		25
#define PREDEF_HIFG_SPEED 		100
#define PREDEF_MOTOR_ID_DEFAULT 		1
#define PREDEF_STEPFREQUENZ 			100.0	//Hz
#define PREDEF_SCAN_INDEX_FRQ 			25.0	//Hz
#define PREDEF_RAMPENSSTARTFRQ			10.0	//Die Frq ab der berhaubt erst eine Rampe gefahren wird..
#define PREDEF_RAMP_RISE 				0	//Anstieg der RampenFrequenz
#define PREDEF_STEPCLOCKS	  			1	//STEPS
#define PREDEF_STEPM_ENABLE_TIMEOUT_SEC	2500 // 2500/Sec  TIMER2_INTPERIODE 10SEC

#define PREDEF_SCANINDEX_TIMEOUT		25000	//100sec 4800 / 60 ~ 80 Sekunden

#define PREDEF_INDEX_OFFFSET	0	// WORK EINSTELLEN
//#define PREDEF_TARGET_X_DIFFERENCE_SPACE	1000

#define PREDEF_BIDIRECTION_MODE	0 // 0=MONO; 1= BiDir
//#define PREDEF_MOTOR_RUN_TIME 		UNLIMITED_MOTOR_RUNTIME	//RERALZEIT IN SEC 600.0 /TIMER2_INTPERIODE (default)//  TIMER  10 MINUTEN


//DIRECTION
#define SM_DIR_RECHTS	0x00 //=PREDEF  SYNCRONzu STEPM_DIRECTION_FLAG
#define SM_DIR_LINKS	0x01 // SYNCRONzu STEPM_DIRECTION_FLAG
#define SM_DIR_DEFAULT 	SM_DIR_RECHTS // SYNCRONzu STEPM_DIRECTION_FLAG

//Es wird unterschieden nach CTRL und Condition Flags

//STEP FRQ
#define FRQ_OFF	0
#define FRQ_ON	1


// DAS muss grer sein als MotorONTime, sonst verhacken sich die Werte..
#define SCAN_INDEX_PULS_DELAY_MS 20 // 50aber 10* da delay nicht so lang ist
//in STRUCT STEPMPARTYPE;
//	uint8_t ucCPUModeFlag;		//COM OUT enabled etc....
//gsStMPar.ucCPUModeFlag
//#define CPUMODEFLAG_COMOUT_ENABLED	0x01	///Com TX ENABLED 

//gsStMPar.ucSysModeFlag 
#define SYSTEM STATUS FLAGS
#define SYS_UART_TX_ENABLED			0x01	//btragen der StartUpInformationen
#define SYS_INFORMATION_FLAG			0x02	//btragen der StartUpInformationen

//GLOBALS DEFINITION       !!!!!!   USES RAM !!!!!
#define STRMAX		64 //frher 61 warum
#define RX_STRMAX		64 //frher 61 warum
//#define SEGMENTSTRMAX 31
//#define NUMMAX			5  //int 0..65535
#define NUMMAX				25 //100.000000  sprintf %f
//#define ORDERSIZE			3	//ABC,1234
//#define VALUEDISTANCE	4	//BEISPIEL SFQ,1000  --> 1000 = 4


//static STEPMPARTYPE gsStMPar;		//SPEICHERT DIE PARAMETER

//DELAYS und Verzgerungen // T= 1/f = 0.016384 ms / Interrupt TIMER2_INTPERIODE
// T= 1/f = 0.016384 ms / Interrupt
//#define TIMER2_INTPERIODE 0.016384 //BY EVERY OVERFLOW  **UNION = 1 Second !

//LCD_SECTION
#define LCD_8Bit_MODE_USED_IN_HEADER 1
#if LCD_8Bit_MODE_USED_IN_HEADER == 1

#define LCD_VALUE1_LINE		1
#define LCD_VALUE2_LINE		2
#define LCD_INFO_LINE		3
#define LCD_SHOW_CMD_LINE	4
#define LCD_NENUE_LINE		4

#define LCD_PINSWITCHDELAY_US	15 //10F mikro sec erforderlich !!zu Schnell; LCD GEHT NIchT MEHR !!
#define LCD_STARTDELAY_MS 1 //10F mikro sec erforderlich !!zu Schnell; LCD GEHT NIchT MEHR !!
#define LCD_INSTRCTIONS_DELAY_MS 4 //10 mikro sec erforderlich !!zu Schnell; LCD GEHT NIchT MEHR !!
#define LCD_AFTERRESETDELAY_US	60 //   mikro sec gerforderlich !!zu Schnell; LCD GEHT NIchT MEHR !!
#define LCD_DAT_IO_PORT 	PORTC //=Port 6 Belegung fr Daten
#define LCD_DAT_DIR_REG 	DDRC
#define LCD_DAT_DIR_MASK 	0XFF	//1111 1111
#define LCD_PORT 		 	PORTD	//Hier nicht echte adr= 7 Belegung fr Steuerung
#define LCD_CMD_DIR_REG 	DDRD  
#define LCD_CMD_DIR_MASK	0b11000000	//1100 0000 
//#define LCDSTRINGMAXCOUNT 33 //2 * 16 + \0
#define LCD_RS		7 //	//Canal xy, bit nn etc.
//#define LCD_RW	//dauerhaft auf GND = Writemode
#define LCD_E1		6 ///Canal xy, bit nn etc.
#define LCD_USED 1	//#endif sign
#define LCDLINEMAXCHAR		(20) // 20 + \0
#define LCDMAXLINES			(4) //
//Speicherordnung des LCD-Disp
//40Zeilig ist wie durchgeschnittene Zweizeilige, rest und angesetzt
//Fr 2_zeilige Anzeigen mit einem durchgehenden Speicher
#define LCD_2_ZEILIG_MEM_1_END 0x4F //Speicher geht weiter als bei 4 Zeiliger Ver
//Fr 4_zeilige Anzeigen mit 2 durchgehenden Speichern
#define LCD_MEM_START 0x00
#define LCD_4_ZEILIG_MEM_1_END 	0x27
#define LCD_4_ZEILIG_MEM_2_START 0x40
#define LCD_4_ZEILIG_MEM_2_END 	0x67
#define WRITE_DD_RAM 0x80 // Commandobit
#define LCD_ROW_ADR1 LCD_MEM_START
#define LCD_ROW_ADR2 LCD_4_ZEILIG_MEM_2_START
#define LCD_ROW_ADR3 (LCD_MEM_START+LCDLINEMAXCHAR)
#define LCD_ROW_ADR4 (LCD_4_ZEILIG_MEM_2_START+LCDLINEMAXCHAR)
#endif

//DELAY
//delay.h 8-bit count, 
// 8-bit count, 3 cycles/loop  _delay_loop_1(uint8_t __count) 
//16-bit count, 4 cycles/loop  _delay_loop_2(uint16_t __count)
//_delay_loop_1(); = 3 CYCLES
//_delay_loop_2(); = 4 CYCLES
//EIn Aufruf von _delay_loop_2 = 4 Cyclen lan = 0.00000025 = 0.250 NanoSecunden
#define OneCycletime	0.0000000625  // 1 / F_CPU
#define DELAYCYCLE_3	0.0000001875 //375ns fr eine Pause //CPU_CYCLE_TIME *3 fr 8 Bit
#define DELAYCYCLE_4 	0.00000025 //500ns fr eine!!! Pause= _delay_loop_2(1); //CPU_CYCLE_TIME *4 fr 16Bit
// 500nS sind 8 * OneCycletime
//1ms= 16000 * OneCycletime
#define DELAY_1NS		4	//4 * 4 Cycles
#define DELAY_1000NS	4000 //()




//Prototypen
void UART_TXRX_Check(void);
void ResetRxBuff(void);
int32_t Round(double fIn);
void StartTimer2(void);	//0.1 Seconds  interrupt

float FloatZahlenRing(float fZahl, float fLimit );

char* FloatToNumStr(double fVal);
char* LongToNumStr(int32_t lVal);
char* ULongToNumStr(uint32_t lVal);

void Print_Str(const char* pStr);
void Print_StrCRLF(const char* pStr); //gsStatus.CRLF_CR_F

void Print_PStr(PGM_P pmStr);
void Print_PStrCRLF(PGM_P pmStr);

void PrintOK_CRLF(void);
void Print_CRLF_CR(void) ;

void PrintFloatCRLF(double fVal);
void PrintLongCRLF(int32_t lVal);
void PrintULongCRLF(uint16_t uiVal);


void CheckOrder(char* pcStr);

void Set_StepMotor_Mode(uint8_t ucVal); 
void SetMotorDirection(uint8_t ucVal);
void Set_StepFRQ(float fVal);
void StepFRQ_OnOff(uint8_t uOnOff);
void StepMotorOn(void);
void StepMotorOff(void);
void StepMotorStop(void); 
void SM_Run_Puls_DIR(uint32_t uiPuls, uint8_t ucDir);
void StartScan_SM_Index(void);

long CalcDegreeIn_SMPos(float fDegree);
float CalcPostionInDegree(long lPos);
void Run_To_SM_Absolute_GradTarget(float fBigWheel_Grad_Target );
void Calc_Shortest_GradPos_Direction(float fBW_Target_GradPos );

#endif  //MAIN_HEADER
